CREATE TYPE [dbo].[AccountList_TVP] 
AS TABLE
(
	AccountNumber varchar(15)
);

GO

CREATE PROCEDURE dbo.GetSalesHeadersByAccountList
(
	@Accounts dbo.AccountList_TVP READONLY
)
AS
BEGIN
	SELECT 
		[Extent1].[SalesOrderID] AS [SalesOrderID], 
		[Extent1].[RevisionNumber] AS [RevisionNumber], 
		[Extent1].[OrderDate] AS [OrderDate], 
		[Extent1].[DueDate] AS [DueDate], 
		[Extent1].[ShipDate] AS [ShipDate], 
		[Extent1].[Status] AS [Status], 
		[Extent1].[OnlineOrderFlag] AS [OnlineOrderFlag], 
		[Extent1].[SalesOrderNumber] AS [SalesOrderNumber], 
		[Extent1].[PurchaseOrderNumber] AS [PurchaseOrderNumber], 
		[Extent1].[AccountNumber] AS [AccountNumber], 
		[Extent1].[CustomerID] AS [CustomerID], 
		[Extent1].[SalesPersonID] AS [SalesPersonID], 
		[Extent1].[TerritoryID] AS [TerritoryID], 
		[Extent1].[BillToAddressID] AS [BillToAddressID], 
		[Extent1].[ShipToAddressID] AS [ShipToAddressID], 
		[Extent1].[ShipMethodID] AS [ShipMethodID], 
		[Extent1].[CreditCardID] AS [CreditCardID], 
		[Extent1].[CreditCardApprovalCode] AS [CreditCardApprovalCode], 
		[Extent1].[CurrencyRateID] AS [CurrencyRateID], 
		[Extent1].[SubTotal] AS [SubTotal], 
		[Extent1].[TaxAmt] AS [TaxAmt], 
		[Extent1].[Freight] AS [Freight], 
		[Extent1].[TotalDue] AS [TotalDue], 
		[Extent1].[Comment] AS [Comment], 
		[Extent1].[rowguid] AS [rowguid], 
		[Extent1].[ModifiedDate] AS [ModifiedDate]
	FROM [Sales].[SalesOrderHeader] AS [Extent1]
	INNER JOIN @Accounts AS [Extent2] ON [Extent1].[AccountNumber] = [Extent2].[AccountNumber]
END
GO