﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SQLskills_EFDemo35
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            //DoSomething();

            //NPlusOneSelect();
            PerformJoinAndAggregate();
        }


        public void NPlusOneSelect()
        {

            using (var aw2008 = new AdventureWorks2008Entities())
            {
                var Accounts = from soh in aw2008.SalesOrderHeaders
                               select soh;

                foreach (var acct in Accounts)
                {
                    var Detail = from soh in aw2008.SalesOrderHeaders
                                 where soh.AccountNumber == acct.AccountNumber
                                 select soh.SalesOrderID;

                    foreach (var order in Detail)
                    {
                        var info = from sod in aw2008.SalesOrderDetails
                                   where sod.SalesOrderID == order
                                   select sod;

                        foreach (var detailrow in info)
                        {
                            int i = detailrow.OrderQty;
                        }
                    }
                }
            }
        }


        public void DoSomething()
        {

            using (AdventureWorks2008Entities aw2008 = new AdventureWorks2008Entities())
            {

                var Accounts = from soh in aw2008.SalesOrderHeaders
                               select soh;

                foreach (var acct in Accounts)
                {
                    var Detail = from soh in aw2008.SalesOrderHeaders
                                 where soh.AccountNumber == acct.AccountNumber
                                 select soh.SalesOrderID;

                    foreach (var order in Detail)
                    {
                        var info = from sod in aw2008.SalesOrderDetails
                                   where sod.SalesOrderID == order
                                   select sod;

                        foreach (var detailrow in info)
                        {
                            int i = detailrow.OrderQty;
                        }
                    }

                }



                // 1. Easy example but not very flexible 
                //    Select all products without any constraints 
                foreach (var product in aw2008.Products)
                {
                    Console.WriteLine(string.Format("{0} | {1} | {2}",
                        product.ProductID, product.Name, product.ListPrice));
                }

                // 2. Same example as above using LINQ 

                foreach (var product in from p in aw2008.Products
                                        select p)
                {
                    Console.WriteLine(string.Format("{0} | {1} | {2}",
                        product.ProductID, product.Name, product.ListPrice));

                }

                // 3. Same example as above externalizing the LINQ query 
                //    Select 20 products without any constraints 
                var query = from p in aw2008.Products
                            select p;

                foreach (var product in query.Take(20))
                {
                    Console.WriteLine(string.Format("{0} | {1} | {2}",
                        product.ProductID, product.Name, product.ListPrice));
                }

            }             
        }

        public void PerformJoinAndAggregate()
        {

            using (AdventureWorks2008Entities aw2008 = new AdventureWorks2008Entities())
            {
                var SalesRecords = from header in aw2008.SalesOrderHeaders
                                   join detail in aw2008.SalesOrderDetails on header.SalesOrderID equals detail.SalesOrderID
                                   where header.AccountNumber == "10-4030-018272"
                                   group new { header, detail }
                                   by new { header.AccountNumber, header.OrderDate }
                                       into grpHeader
                                       let totalItems = grpHeader.Sum(x => x.detail.OrderQty)
                                       select new
                                       {
                                           AccountNumber = grpHeader.Key.AccountNumber,
                                           OrderDate = grpHeader.Key.OrderDate,
                                           TotalItems = totalItems
                                       };

                foreach (var saleReccord in SalesRecords)
                {
                    Console.WriteLine(saleReccord.AccountNumber);
                    Console.WriteLine(saleReccord.OrderDate);
                    Console.WriteLine(saleReccord.TotalItems);
                }
            }
        }


    }
}
