﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Configuration;
using System.Diagnostics;

namespace SQLskills_L2SDemo35
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void BadParameterization()
        {
            DataContext db = new DataContext(ConfigurationManager.ConnectionStrings["AdventureWorks2008"].ConnectionString);
            Table<SalesOrderDetail> SalesOrderDetail = db.GetTable<SalesOrderDetail>();
            Table<SalesOrderHeader> SalesOrderHeader = db.GetTable<SalesOrderHeader>();
            Table<Person> Person = db.GetTable<Person>();

            var John = from p in Person
                         where p.FirstName == "John"
                         select p;

            var Kimberly = from p in Person
                       where p.FirstName == "Kimberly"
                       select p;

            var Joe = from p in Person
                         where p.FirstName == "Joe"
                         select p;

            var Glenn = from p in Person
                        where p.FirstName == "Glenn"
                        select p;

            foreach (var p in John)
            {
                Debug.Write(p.FirstName);
            }

            foreach (var p in Joe)
            {
                Debug.Write(p.FirstName);
            }

            foreach (var p in Glenn)
            {
                Debug.Write(p.FirstName);
            }

            foreach (var p in Kimberly)
            {
                Debug.Write(p.FirstName);
            }

                        

            var Accounts = from soh in SalesOrderHeader
                           select soh;

            foreach (var acct in Accounts)
            {
                var Detail = from soh in SalesOrderHeader
                             where soh.AccountNumber == acct.AccountNumber
                             select soh.SalesOrderID;

                foreach (var order in Detail)
                {
                    var info = from sod in SalesOrderDetail
                               where sod.SalesOrderID == order
                               select sod;

                    foreach (var detailrow in info)
                    {
                        int i = detailrow.SpecialOfferID;
                    }
                }

            }



        }

        private void CorrectParameterization()
        {
            DataContext db = new DataContext(ConfigurationManager.ConnectionStrings["AdventureWorks2008"].ConnectionString);
            Table<SalesOrderDetail> SalesOrderDetail = db.GetTable<SalesOrderDetail>();
            Table<SalesOrderHeader> SalesOrderHeader = db.GetTable<SalesOrderHeader>();


            var Accounts = from soh in SalesOrderHeader
                           select soh.AccountNumber;

            foreach (var acct in Accounts)
            {
                IQueryable<int> Details = from soh in SalesOrderHeader
                                          where soh.AccountNumber == acct
                                          select soh.SalesOrderID;

                //Get the SQL command translation of the query...
                System.Data.Common.DbCommand command = db.GetCommand(Details);

                //Change param type from "string" (nvarchar) to "ansistring" (varchar)
                command.Parameters[0].DbType = System.Data.DbType.AnsiString;

                //Set the length of the parameter
                command.Parameters[0].Size = 15;

                //Create new connection
                DataContext db2 = new DataContext(ConfigurationManager.ConnectionStrings["AdventureWorks2008"].ConnectionString);
                command.Connection = db2.Connection;
                command.Connection.Open();

                //Run the new parameterized command
                var Detail = db.Translate<int>(command.ExecuteReader());


                foreach (var order in Detail)
                {
                    var info = from sod in SalesOrderDetail
                               where sod.SalesOrderID == order
                               select sod;

                    foreach (var detailrow in info)
                    {
                        int i = detailrow.SpecialOfferID;
                    }
                }

            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            BadParameterization();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            CorrectParameterization();
        }

    }
}
